0 / 0 / 0
Регистрация: 03.01.2020
Сообщений: 9
1

Django.core.exceptions.ImproperlyConfigured (django1.8->3.)

27.03.2020, 02:10. Показов 1856. Ответов 8

Здравствуйте!
Подскажите, пожалуйста, как мне правильно адаптировать под джанго 3.0 данную строчку?
Python
1
2
urlpatterns = [
    url(r'^', include('shop.urls', namespace='shop'))]
Для контекста - учусь писать интернет-магазин по данному сайту, там используется джанго версии 1.8.6. Встал именно на этой строке (Создание каталога)

В архиве прикрепил то, что уже написано и более-менее работоспособно: mysite.rar или mysite.zip

Помогите, пожалуйста. Просто более подробных туториалов я не нашел (есть еще от mozilla developers хорошее пособие, но мне нужен именно интернет-магазин)
__________________
Помощь в написании контрольных, курсовых и дипломных работ, диссертаций здесь
0
Programming
Эксперт
94731 / 64177 / 26122
Регистрация: 12.04.2006
Сообщений: 116,782
27.03.2020, 02:10
Ответы с готовыми решениями:

Apache2.2+django1.4.3.+python2.7+ WINDOWS
Здравствуйте. У меня такая ситуация: Есть проект небольшого web - приложения написанного нa python...

Настроить авторизацию через социальные сети в django с помощью Django Social Auth
Пытаюсь настроить авторизацию через социальные сети в django с помощью Django Social Auth, но...

Ошибка django: DoesNotExist at /catalog/ django
Здравствуйте. Пишу простейший сайт на django. Пока в нем есть верхняя панель навигации и боковое...

Exceptions в Qt
Здравствуйте! В Qt новичок (в принципе и в С++ нуб), прошу помощи. Пытаюсь обработать исключения,...

8
1 / 1 / 0
Регистрация: 08.03.2020
Сообщений: 33
27.03.2020, 13:50 2
Python
1
2
3
4
5
from django.urls import path, include
 
urlpatterns = [
    path('', include('shop.urls', namespace='shop')),
]
0
0 / 0 / 0
Регистрация: 03.01.2020
Сообщений: 9
27.03.2020, 16:23  [ТС] 3
Уже пробовал так. И, к сожалению, выводит ошибку
Python
1
django.core.exceptions.ImproperlyConfigured: Specifying a namespace in include() without providing an app_name is not supported. Set the app_name attribute in the included module, or pass a 2-tuple containing the list of patterns and app_name instead.
Под спойлером полный текст ошибки
Кликните здесь для просмотра всего текста

(myshop) C:\Users\Администратор\mysite>python manage.py makemigrations
Traceback (most recent call last):
File "manage.py", line 21, in <module>
main()
File "manage.py", line 17, in main
execute_from_command_line(sys.argv)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\management\__init__.py", line 401, in execute_from_command_line
utility.execute()
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\management\__init__.py", line 395, in execute
self.fetch_command(subcommand).run_from_argv(self. argv)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\management\base.py", line 328, in run_from_argv
self.execute(*args, **cmd_options)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\management\base.py", line 366, in execute
self.check()
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\management\base.py", line 392, in check
all_issues = self._run_checks(
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\management\base.py", line 382, in _run_checks
return checks.run_checks(**kwargs)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\checks\registry.py", line 72, in run_checks
new_errors = check(app_configs=app_configs)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\checks\urls.py", line 13, in check_url_config
return check_resolver(resolver)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\checks\urls.py", line 23, in check_resolver
return check_method()
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\urls\resolvers.py", line 407, in check
for pattern in self.url_patterns:
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\utils\functional.py", line 48, in __get__
res = instance.__dict__[self.name] = self.func(instance)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\urls\resolvers.py", line 588, in url_patterns
patterns = getattr(self.urlconf_module, "urlpatterns", self.urlconf_module)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\utils\functional.py", line 48, in __get__
res = instance.__dict__[self.name] = self.func(instance)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\urls\resolvers.py", line 581, in urlconf_module
return import_module(self.urlconf_name)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\importlib\__init__.py", line 127, in import_module
return _bootstrap._gcd_import(name[level:], package, level)
File "<frozen importlib._bootstrap>", line 1014, in _gcd_import
File "<frozen importlib._bootstrap>", line 991, in _find_and_load
File "<frozen importlib._bootstrap>", line 975, in _find_and_load_unlocked
File "<frozen importlib._bootstrap>", line 671, in _load_unlocked
File "<frozen importlib._bootstrap_external>", line 783, in exec_module
File "<frozen importlib._bootstrap>", line 219, in _call_with_frames_removed
File "C:\Users\Администратор\mysite\mysite\urls.py" , line 22, in <module>
path('', include('shop.urls', namespace='shop')),
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\urls\conf.py", line 38, in include
raise ImproperlyConfigured(
django.core.exceptions.ImproperlyConfigured: Specifying a namespace in include() without providing an app_name is not supported. Set the app_name attribute in the included module, or pass a 2-tuple containing the list of patterns and app_name instead.
0
1 / 1 / 0
Регистрация: 08.03.2020
Сообщений: 33
27.03.2020, 17:17 4
Попробуйте так:
Python
1
path('', include(('shop.urls', 'shop'), namespace='shop')),
Ссылка на документацию: https://docs.djangoproject.com... s/#include
1
0 / 0 / 0
Регистрация: 03.01.2020
Сообщений: 9
27.03.2020, 19:01  [ТС] 5
Спасибо за ответ) вы оказались правы - эта ошибка ушла, появилась другая.
Python
1
django.core.exceptions.ImproperlyConfigured: "^<id>\d+)/(?P<slug>[-w]+)/$" is not a valid regular expression: unbalanced parenthesis at position 8
я так понимаю ошибка в данном коде
Python
1
2
3
4
5
6
7
8
9
10
11
from django.conf.urls import url
from . import views
 
urlpatterns = [
    url(r'^$', views.product_list, name='product_list'),
    url(r'^(?P<category_slug>[-\w]+)/$',
        views.product_list,
        name='product_list_by_category'),
    url(r'^<id>\d+)/(?P<slug>[-w]+)/$',
        views.product_detail, name='product_detail'),
]
полный текст ошибки
Кликните здесь для просмотра всего текста

(myshop) C:\Users\Администратор\mysite>python manage.py makemigrations
Traceback (most recent call last):
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\urls\resolvers.py", line 189, in _compile
return re.compile(regex)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\re.py", line 250, in compile
return _compile(pattern, flags)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\re.py", line 302, in _compile
p = sre_compile.compile(pattern, flags)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\sre_compile.py", line 764, in compile
p = sre_parse.parse(p, flags)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\sre_parse.py", line 962, in parse
raise source.error("unbalanced parenthesis")
re.error: unbalanced parenthesis at position 8

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File "manage.py", line 21, in <module>
main()
File "manage.py", line 17, in main
execute_from_command_line(sys.argv)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\management\__init__.py", line 401, in execute_from_command_line
utility.execute()
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\management\__init__.py", line 395, in execute
self.fetch_command(subcommand).run_from_argv(self. argv)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\management\base.py", line 328, in run_from_argv
self.execute(*args, **cmd_options)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\management\base.py", line 366, in execute
self.check()
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\management\base.py", line 392, in check
all_issues = self._run_checks(
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\management\base.py", line 382, in _run_checks
return checks.run_checks(**kwargs)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\checks\registry.py", line 72, in run_checks
new_errors = check(app_configs=app_configs)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\checks\urls.py", line 13, in check_url_config
return check_resolver(resolver)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\checks\urls.py", line 23, in check_resolver
return check_method()
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\urls\resolvers.py", line 408, in check
messages.extend(check_resolver(pattern))
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\checks\urls.py", line 23, in check_resolver
return check_method()
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\urls\resolvers.py", line 408, in check
messages.extend(check_resolver(pattern))
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\core\checks\urls.py", line 23, in check_resolver
return check_method()
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\urls\resolvers.py", line 335, in check
warnings.extend(self.pattern.check())
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\urls\resolvers.py", line 169, in check
warnings.extend(self._check_pattern_startswith_sla sh())
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\urls\resolvers.py", line 126, in _check_pattern_startswith_slash
regex_pattern = self.regex.pattern
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\urls\resolvers.py", line 104, in __get__
instance.__dict__['regex'] = instance._compile(pattern)
File "C:\Users\Администратор\AppData\Local\Programs\Pyt hon\Python38-32\lib\site-packages\django\urls\resolvers.py", line 191, in _compile
raise ImproperlyConfigured(
django.core.exceptions.ImproperlyConfigured: "^<id>\d+)/(?P<slug>[-w]+)/$" is not a valid regular expression: unbalanced parenthesis at position 8


Но вот это пока что для меня темный лес) пойду изучать документацию.
0
1 / 1 / 0
Регистрация: 08.03.2020
Сообщений: 33
27.03.2020, 19:52 6
Могу только предположить потому, что я сам только начал изучать django.

django 1.8:
Python
1
url(r'^<id>\d+)/(?P<slug>[-w]+)/$', views.product_detail, name='product_detail'),
django 3:
Python
1
path('<int:id>/<str:slug>', views.product_detail, name='product_detail'),
Пусть умный человек придёт, закидает меня камнями и скажет как нужно.))
0
0 / 0 / 0
Регистрация: 03.01.2020
Сообщений: 9
27.03.2020, 21:50  [ТС] 7
К сожалению, это тоже не помогло)) сейчас перечитываю офф.документацию по этому поводу. но понять все-равно не могу(
0
1035 / 570 / 242
Регистрация: 15.01.2019
Сообщений: 2,175
Записей в блоге: 1
29.03.2020, 12:32 8
Relizerel, если нужна регулярка, то используй re_path
https://docs.djangoproject.com... xpressions
Python
1
re_path(r'^(?P<id>[\d+])/(?P<slug>[\w-]+)/$', views.product_detail, name='product_detail')
0
0 / 0 / 0
Регистрация: 03.01.2020
Сообщений: 9
29.03.2020, 19:11  [ТС] 9
m0nte-cr1st0, спасибо за ответ.
У меня нет цели использовать регулярки, у меня есть цель понять, что происходит в данном коде, как он работает... И заставить его работать в джанго 3. Сейчас адекватных туториала по джанго - документация официальная и от mozilla, но только вот там создаются простые блоги, а мне нужен интернет магазин.
Спасибо за ответ, проверю)
0
IT_Exp
Эксперт
87844 / 49110 / 22898
Регистрация: 17.06.2006
Сообщений: 92,604
29.03.2020, 19:11
Помогаю со студенческими работами здесь

Exceptions
1) Создайте 2 класса-наследника от Exception: NullException и NoNumberException. 2) В классе...

Exceptions
Здравствуйте! В данный момент изучаю исключения и необходимо было создать исключение, если юзер...

Throw exceptions
В массиве нужно отловить все исключения. Скока их ?...

InputStream exceptions
Дано: серверный чат на TCP сокетах. Есть DataInputStream, который принимает в себя InputStream из...


Искать еще темы с ответами

Или воспользуйтесь поиском по форуму:
9
Ответ Создать тему
Опции темы

КиберФорум - форум программистов, компьютерный форум, программирование
Powered by vBulletin
Copyright ©2000 - 2022, CyberForum.ru